/*==============================================================================


       eg_16 - File display & the mmc

               Copyright  2001 Pankhurst Algorithmics - All Rights Reserved
               visit www.ebmDevMag.com for permissions/restrictions on use

==============================================================================*/
#include <string.h>

#include "gui.h"
extern "C"
{
#include "ereader_hostio.h"
}
#include "eg_16_form.h"
#include "dlg_file.h"
/*==============================================================================

       main window routines

==============================================================================*/
void CWindow1::Initialize(void)
{
  m_caption[0]='\0';
  LABEL_FILE->SetLabel(m_caption);
}
//------------------------------------------------------------------------------
S32 CWindow1::MsgHandler( MSG_TYPE type, CViewable *from, S32 data )
{
  // process button/radio button messages
  if ( MSG_BUTTON_SELECT==type ) // show dialog?
  {
    ebo_enumerator_t info;
    char *ptr="";
    if (OpenDialog(&info,"FXE"))
      ptr=info.name.name; // copy name to onscreen label
    else // not found
    {
      ptr="No file selected!";
      GUI_Alert(ALERT_WARNING,ptr);
    }
    // set file description into label
    strncpy(m_caption,ptr,sizeof(m_caption)),  m_caption[sizeof(m_caption)-1]='\0';
    LABEL_FILE->SetLabel(m_caption);
    // ...and now center it
    RECT rect;
    GetUsableRect(&rect);
    int len=GUI_TextWidth(GetFont(),m_caption,-1);
    LABEL_FILE->SetX( (rect.width-len)/2 );
  }
    return 1;
  return CWindow::MsgHandler(type, from, data);
}
/*==============================================================================


==============================================================================*/
static CWindow1 *f_mainWindow;
//------------------------------------------------------------------------------
S32 GUI_main( MSG_TYPE type, CViewable *object, S32 data )
{
  switch (type)
  {
    case MSG_APP_START:
      if (OS_is_present && hostIO_am_I_the_current_task())
        HOSTIO_INLINE_BREAKPOINT();
      f_mainWindow = new CWindow1();
      f_mainWindow->Initialize();
      return 1;
    case MSG_APP_STOP:
      delete f_mainWindow;
      return 1;
    default:
      break;
  }
  return 0;
};
//------------------------------------------------------------------------------



